import { Store } from './util';
export declare class TypeError extends Error {
    readonly cause?: Error;
    constructor(message: string, cause?: Error);
}
export interface Newable<T> {
    new (...args: any[]): T;
}
export default class TypeConf {
    private readonly override;
    private readonly stores;
    private rootAccessor;
    constructor();
    private resolve(name);
    private exists(name);
    protected addStore(store: Store, name: string): void;
    withStore(storage: {
        [key: string]: any;
    }, name?: string): TypeConf;
    withSupplier(supplier: (key: string) => any, name?: string): TypeConf;
    set(key: string, value: any): TypeConf;
    unset(key: string): TypeConf;
    get<T>(name: string, transform: (x: any) => T): T;
    get<T>(name: string, transform?: undefined): any;
    getString(name: string, fallback: string): string;
    getString(name: string, fallback?: string): string | undefined;
    getNumber(name: string, fallback: number): number;
    getNumber(name: string, fallback?: number): number | undefined;
    getBoolean(name: string): boolean;
    getObject(name: string, fallback: object): object;
    getObject(name: string, fallback?: object): object | undefined;
    getType<T>(name: string, newable: Newable<T>, fallback: T): T;
    getType<T>(name: string, newable: Newable<T>, fallback?: T): T | undefined;
}
