export interface Accessor {
    (name: string, peek: true): boolean;
    (name: string, peek: false): any;
    (name: string, peek?: boolean): any;
}
export interface Store {
    get(name: string, next: Accessor): any;
    has(name: string, next: Accessor): boolean;
}
export declare type Storage = {
    [name: string]: any;
} | ((name: string) => any);
export declare function createStore(storage: Storage, nameModifier?: (name: string) => string): {
    get: (name: string, next: Accessor) => any;
    has: (name: string, next: Accessor) => boolean;
};
export declare function createAccessor(store: Store, next: Accessor): Accessor;
export declare const baseAccessor: (_: string, peek?: boolean | undefined) => any;
