"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function getValueOrNext(name, storage, next) {
    const value = typeof storage === 'function' ? storage(name) : storage[name];
    return value !== undefined ? value : next(name);
}
function peekValueOrNext(name, storage, next) {
    const exists = typeof storage === 'function' ? storage(name) !== undefined : name in storage;
    return exists || next(name, true);
}
function createStore(storage, nameModifier = _ => _) {
    return {
        get: (name, next) => getValueOrNext(nameModifier(name), storage, next),
        has: (name, next) => peekValueOrNext(nameModifier(name), storage, next)
    };
}
exports.createStore = createStore;
function createAccessor(store, next) {
    return (name, peek) => {
        if (peek === true) {
            return store.has(name, next);
        }
        else {
            return store.get(name, next);
        }
    };
}
exports.createAccessor = createAccessor;
exports.baseAccessor = (_, peek) => {
    if (peek === true)
        return false;
    else
        return undefined;
};
//# sourceMappingURL=util.js.map